/*
 * This is the usage and help routines
 */

#include <stdio.h>


usage(pname)
char *pname;
{
  fprintf(stderr,"Usage: %s [-p packet] [-t type] [-l loops] source target\n",pname);
  fprintf(stderr,"Defaults:\n");
  fprintf(stderr,"LOOPS  1\n");
  fprintf(stderr,"DATA   64\n");
  fprintf(stderr,"PACKET echo\n\n");
  fprintf(stderr,"If loops is 0 it will continously send packets\n");
  fprintf(stderr,"If packet type is 'redirect', 'unreach', or 'maxtime'\n");
  fprintf(stderr,"you must specify a type\n");
  fprintf(stderr,"For a list of packets and types, type: %s -h\n",pname);
  exit(0);
}





help(pname)
char *pname;
{
  printf("\nPacket types:\n"
    "echorply unreach quench redirect echo maxtime param\n"
    "tstamp tstamprply info inforply mask maskrply\n");

  printf("\nUnreachable types\n"
	 "\tnet\t\tNetwork is unreachable\n"
	 "\thost\t\tHost is unreachable [default]\n"
	 "\tprotocol\tBad protocol\n"
	 "\tport\t\tBad Port\n"
	 "\tfrag\t\tIP_DF caused drop\n"
	 "\tsource\t\tSource route failed\n"
	 "\tdestnet\t\tNetwork unknown\n"
	 "\tdesthost\tHost unknown\n"
	 "\tisolated\tNetwork is isolated\n"
	 "\tauthnet\t\tAuthorization failed for network\n"
	 "\tauthhost\tAuthorization failed for host\n"
	 "\tnetsvc\t\tNetwork Service is unrachable\n"
	 "\thostsvc\t\tHost service is unreachable\n");

  printf("\nRedirect types\n"
	 "\tnet\t\tNetwork redirect\n"
	 "\thost\t\tHost redirect\n"
	 "\ttosnet\t\ttos and net\n"
	 "\ttoshost\t\ttos and host\n");

  printf("\nMaxtime types\n"
	 "\ttransit\t\tIn transit\n"
	 "\treassembly\tDuring Reassembly\n");
	 
  exit(0);
}
