/*
 * Misc routines that didnt really fit elsewhere
 */

#include <stdio.h>
#include <sys/types.h>


#define MAX_UNREACH  13
#define MAX_REDIRECT  4
#define MAX_TIME      2
#define MAX_PACKET   19

int resolve_type(arg,packet)
char *arg;
int packet;
{
  int i;
  static char *redir_type[] = {"net","host","tosnet","toshost"};
  static char *unreach_type[] = {
    "net","host","protocol","port","frag","source","destnet",
    "desthost","isolated","authnet","authhost","netsvc","hostsvc"};
  static char *time_type[]={"transit","reassembly"};
  
  switch(packet) {
  case 3:
    for(i=0;i<MAX_UNREACH;i++) if(strcmp(arg,unreach_type[i])==0) return(i);
    break;
  case 5:
    for(i=0;i<MAX_REDIRECT;i++) if(strcmp(arg,redir_type[i])==0) return(i);
    break;
  case 11:
    for(i=0;i<MAX_TIME;i++) if(strcmp(arg,time_type[i])==0) return(i);
    break;
  }

  fprintf(stderr,"Invalid type\n");
  return(-1);
}

int resolve_packet(arg)
char *arg;
{
  int i;
  static char *icmp_packet[] = {
    "echorply","void","void","unreach","quench","redirect","void","void",
    "echo","void","void","maxtime","param","tstamp","tstamprply","info",
    "inforply","mask","maskrply"};

  /* Void is either an unsupported type, or a non existant type */
  if(strcmp(arg,"void")==0) return(-1);
  for(i=0; i <MAX_PACKET; i++) {
    if(strcmp(arg,icmp_packet[i])==0) return(i);
  }
  fprintf(stderr,"Invalid packet type\n");
  return(-1);
}





int in_cksum(ptr, nbytes)
u_short *ptr;
int nbytes;
{
  register long     sum;       /* assumes long == 32 bits */
  u_short           oddbyte;
  register u_short  answer;    /* assumes u_short == 16 bits */

  /*
   *  Our algorithm is simple, using a 32 bit accumulator (sum),
   *  we add sequential 16 bit words to it, and at the end, fold back
   *  all the carry bits from the top 16 bits into the lower 16 bits
   */

  sum = 0;
  while( nbytes > 1 )  {
    sum += *ptr++;
    nbytes -= 2;
  }
  
                   /* mop up an odd byte, if necessary */
  if( nbytes == 1 ) {
    oddbyte = 0;
    *((u_char *) &oddbyte) = *(u_char *)ptr;  /* one byte only */
    sum += oddbyte;
  }
  
  /*
   * add back carry outs from top 16 bits to low 16 bits
   */

  sum = (sum >> 16) + (sum & 0xffff);     /* add high-16 to low-16 */
  sum += (sum >> 16);                     /* add carry */
  answer = ~sum;         /* ones-complement, then truncate to 16 bits */
  return (answer);
}
